----------------------------------------------------------------------------- 
-- Altera DSP Builder Advanced Flow Tools Release Version 12.0sp2
-- Quartus II development tool and MATLAB/Simulink Interface
-- 
-- Legal Notice: Copyright 2012 Altera Corporation.  All rights reserved.    
-- Your use of  Altera  Corporation's design tools,  logic functions and other 
-- software and tools,  and its AMPP  partner logic functions, and  any output 
-- files  any of the  foregoing  device programming or simulation files),  and 
-- any associated  documentation or information are expressly subject  to  the 
-- terms and conditions  of the Altera Program License Subscription Agreement, 
-- Altera  MegaCore  Function  License  Agreement, or other applicable license 
-- agreement,  including,  without limitation,  that your use  is for the sole 
-- purpose of  programming  logic  devices  manufactured by Altera and sold by 
-- Altera or its authorized  distributors.  Please  refer  to  the  applicable 
-- agreement for further details.
----------------------------------------------------------------------------- 

-- VHDL created from DOC_FOC_fixp16_ax4_FOC
-- VHDL created on Wed Aug 29 14:41:36 2012


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.NUMERIC_STD.all;
use std.TextIO.all;
USE work.DOC_FOC_fixp16_ax4_safe_path.all;

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3097
entity DOC_FOC_fixp16_ax4_FOC_stm is
    port (
         I_Sat_Limit_cfg_stm : out std_logic_vector(15 downto 0);
         Iu_stm : out std_logic_vector(15 downto 0);
         Iw_stm : out std_logic_vector(15 downto 0);
         Ki_cfg_stm : out std_logic_vector(15 downto 0);
         Kp_cfg_stm : out std_logic_vector(15 downto 0);
         U_Sat_Limit_cfg_stm : out std_logic_vector(15 downto 0);
         Valpha_stm : out std_logic_vector(31 downto 0);
         Vbeta_stm : out std_logic_vector(31 downto 0);
         axis_in_stm : out std_logic_vector(7 downto 0);
         axis_out_stm : out std_logic_vector(7 downto 0);
         debug_1_stm : out std_logic_vector(15 downto 0);
         debug_2_stm : out std_logic_vector(15 downto 0);
         debug_3_stm : out std_logic_vector(15 downto 0);
         dv_stm : out std_logic_vector(0 downto 0);
         phi_el_stm : out std_logic_vector(15 downto 0);
         qv_stm : out std_logic_vector(0 downto 0);
         reset_stm : out std_logic_vector(0 downto 0);
         torque_stm : out std_logic_vector(15 downto 0);
         valid_in_stm : out std_logic_vector(0 downto 0);
         valid_out_stm : out std_logic_vector(0 downto 0);
        clk : out std_logic;
        areset : out std_logic;
        h_areset : out std_logic
    );
end;

architecture normal of DOC_FOC_fixp16_ax4_FOC_stm is

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3106
    signal clk_stm_sig : std_logic := '0';
    signal clk_stm_sig_stop : std_logic := '0';
    signal areset_stm_sig : std_logic := '1';
    signal h_areset_stm_sig : std_logic := '1';
    signal clk_I_Sat_Limit_cfg_auto_stm_sig_stop : std_logic := '0';
    signal clk_Iu_auto_stm_sig_stop : std_logic := '0';
    signal clk_Iw_auto_stm_sig_stop : std_logic := '0';
    signal clk_Ki_cfg_auto_stm_sig_stop : std_logic := '0';
    signal clk_Kp_cfg_auto_stm_sig_stop : std_logic := '0';
    signal clk_U_Sat_Limit_cfg_auto_stm_sig_stop : std_logic := '0';
    signal clk_Valpha_auto_stm_sig_stop : std_logic := '0';
    signal clk_Vbeta_auto_stm_sig_stop : std_logic := '0';
    signal clk_axis_in_auto_stm_sig_stop : std_logic := '0';
    signal clk_axis_out_auto_stm_sig_stop : std_logic := '0';
    signal clk_debug_1_auto_stm_sig_stop : std_logic := '0';
    signal clk_debug_2_auto_stm_sig_stop : std_logic := '0';
    signal clk_debug_3_auto_stm_sig_stop : std_logic := '0';
    signal clk_dv_auto_stm_sig_stop : std_logic := '0';
    signal clk_phi_el_auto_stm_sig_stop : std_logic := '0';
    signal clk_qv_auto_stm_sig_stop : std_logic := '0';
    signal clk_torque_auto_stm_sig_stop : std_logic := '0';
    signal clk_valid_in_auto_stm_sig_stop : std_logic := '0';
    signal clk_valid_out_auto_stm_sig_stop : std_logic := '0';

    function str_to_stdvec(inp: string) return std_logic_vector is
        variable temp: std_logic_vector(inp'range) := (others => 'X');
    begin
        for i in inp'range loop
            if (inp(i) = '1') then
                temp(i) := '1';
            elsif (inp(i) = '0') then
                temp(i) := '0';
            end if;
        end loop;
        return temp;
    end function str_to_stdvec;

begin
    clk <= clk_stm_sig;
    clk_process: process 
    begin
        wait for 200 ps;
        clk_stm_sig <= not clk_stm_sig;
        wait for 4800 ps;
        if (clk_stm_sig_stop = '1') then
            assert (false)
            report "Arrived at end of stimulus data on clk clk" severity NOTE;
            wait;
        end if;
        wait for 200 ps;
        clk_stm_sig <= not clk_stm_sig;
        wait for 4800 ps;
        if (clk_stm_sig_stop = '1') then
            assert (false)
            report "Arrived at end of stimulus data on clk clk" severity NOTE;
            wait;
        end if;
    end process;

    areset <= areset_stm_sig;
    areset_process: process begin
        areset_stm_sig <= '1';
        wait for 7500 ps;
        areset_stm_sig <= '0';
        wait;
    end process;

    h_areset <= h_areset_stm_sig;
    h_areset_process: process begin
        h_areset_stm_sig <= '1';
        wait for 7500 ps;
        h_areset_stm_sig <= '0';
        wait;
    end process;

    --Generating stimulus for I_Sat_Limit_cfg_auto
    I_Sat_Limit_cfg_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable I_Sat_Limit_int_0 : Integer;
        variable I_Sat_Limit_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        I_Sat_Limit_cfg_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to I_Sat_Limit_cfg_auto)
            if endfile(data_file_ChannelIn) then
                clk_I_Sat_Limit_cfg_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, I_Sat_Limit_int_0);
                I_Sat_Limit_temp(15 downto 0) := std_logic_vector(to_unsigned(I_Sat_Limit_int_0, 16));
                I_Sat_Limit_cfg_stm <= I_Sat_Limit_temp;

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for Iu_auto
    Iu_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable Iu_int_0 : Integer;
        variable Iu_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        Iu_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to Iu_auto)
            if endfile(data_file_ChannelIn) then
                clk_Iu_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Iu_int_0);
                Iu_temp(15 downto 0) := std_logic_vector(to_unsigned(Iu_int_0, 16));
                Iu_stm <= Iu_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for Iw_auto
    Iw_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable Iw_int_0 : Integer;
        variable Iw_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        Iw_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to Iw_auto)
            if endfile(data_file_ChannelIn) then
                clk_Iw_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Iw_int_0);
                Iw_temp(15 downto 0) := std_logic_vector(to_unsigned(Iw_int_0, 16));
                Iw_stm <= Iw_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for Ki_cfg_auto
    Ki_cfg_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable Ki_int_0 : Integer;
        variable Ki_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        Ki_cfg_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to Ki_cfg_auto)
            if endfile(data_file_ChannelIn) then
                clk_Ki_cfg_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Ki_int_0);
                Ki_temp(15 downto 0) := std_logic_vector(to_unsigned(Ki_int_0, 16));
                Ki_cfg_stm <= Ki_temp;
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for Kp_cfg_auto
    Kp_cfg_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable Kp_int_0 : Integer;
        variable Kp_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        Kp_cfg_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to Kp_cfg_auto)
            if endfile(data_file_ChannelIn) then
                clk_Kp_cfg_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Kp_int_0);
                Kp_temp(15 downto 0) := std_logic_vector(to_unsigned(Kp_int_0, 16));
                Kp_cfg_stm <= Kp_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for U_Sat_Limit_cfg_auto
    U_Sat_Limit_cfg_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable U_Sat_Limit_int_0 : Integer;
        variable U_Sat_Limit_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        U_Sat_Limit_cfg_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to U_Sat_Limit_cfg_auto)
            if endfile(data_file_ChannelIn) then
                clk_U_Sat_Limit_cfg_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, U_Sat_Limit_int_0);
                U_Sat_Limit_temp(15 downto 0) := std_logic_vector(to_unsigned(U_Sat_Limit_int_0, 16));
                U_Sat_Limit_cfg_stm <= U_Sat_Limit_temp;
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for Valpha_auto
    Valpha_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable Valpha_int_0 : Integer;
        variable Valpha_temp : std_logic_vector(31 downto 0);

    begin
        -- initialize all outputs to 0
        Valpha_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to Valpha_auto)
            if endfile(data_file_ChannelOut) then
                clk_Valpha_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Valpha_int_0);
                Valpha_temp(31 downto 0) := std_logic_vector(to_signed(Valpha_int_0, 32));
                Valpha_stm <= Valpha_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for Vbeta_auto
    Vbeta_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable Vbeta_int_0 : Integer;
        variable Vbeta_temp : std_logic_vector(31 downto 0);

    begin
        -- initialize all outputs to 0
        Vbeta_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to Vbeta_auto)
            if endfile(data_file_ChannelOut) then
                clk_Vbeta_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Vbeta_int_0);
                Vbeta_temp(31 downto 0) := std_logic_vector(to_signed(Vbeta_int_0, 32));
                Vbeta_stm <= Vbeta_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for axis_in_auto
    axis_in_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable axis_in_int_0 : Integer;
        variable axis_in_temp : std_logic_vector(7 downto 0);

    begin
        -- initialize all outputs to 0
        axis_in_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to axis_in_auto)
            if endfile(data_file_ChannelIn) then
                clk_axis_in_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, axis_in_int_0);
                axis_in_temp(7 downto 0) := std_logic_vector(to_unsigned(axis_in_int_0, 8));
                axis_in_stm <= axis_in_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for axis_out_auto
    axis_out_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable axis_out_int_0 : Integer;
        variable axis_out_temp : std_logic_vector(7 downto 0);

    begin
        -- initialize all outputs to 0
        axis_out_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to axis_out_auto)
            if endfile(data_file_ChannelOut) then
                clk_axis_out_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, axis_out_int_0);
                axis_out_temp(7 downto 0) := std_logic_vector(to_unsigned(axis_out_int_0, 8));
                axis_out_stm <= axis_out_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for debug_1_auto
    debug_1_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable debug_1_int_0 : Integer;
        variable debug_1_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        debug_1_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to debug_1_auto)
            if endfile(data_file_ChannelOut) then
                clk_debug_1_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, debug_1_int_0);
                debug_1_temp(15 downto 0) := std_logic_vector(to_unsigned(debug_1_int_0, 16));
                debug_1_stm <= debug_1_temp;
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for debug_2_auto
    debug_2_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable debug_2_int_0 : Integer;
        variable debug_2_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        debug_2_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to debug_2_auto)
            if endfile(data_file_ChannelOut) then
                clk_debug_2_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, debug_2_int_0);
                debug_2_temp(15 downto 0) := std_logic_vector(to_unsigned(debug_2_int_0, 16));
                debug_2_stm <= debug_2_temp;
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for debug_3_auto
    debug_3_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable debug_3_int_0 : Integer;
        variable debug_3_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        debug_3_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to debug_3_auto)
            if endfile(data_file_ChannelOut) then
                clk_debug_3_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, debug_3_int_0);
                debug_3_temp(15 downto 0) := std_logic_vector(to_unsigned(debug_3_int_0, 16));
                debug_3_stm <= debug_3_temp;

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for dv_auto
    dv_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable dv_int_0 : Integer;
        variable dv_temp : std_logic_vector(0 downto 0);

    begin
        -- initialize all outputs to 0
        dv_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to dv_auto)
            if endfile(data_file_ChannelIn) then
                clk_dv_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dv_int_0);
                dv_temp(0 downto 0) := std_logic_vector(to_unsigned(dv_int_0, 1));
                dv_stm <= dv_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for phi_el_auto
    phi_el_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable phi_el_int_0 : Integer;
        variable phi_el_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        phi_el_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to phi_el_auto)
            if endfile(data_file_ChannelIn) then
                clk_phi_el_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, phi_el_int_0);
                phi_el_temp(15 downto 0) := std_logic_vector(to_unsigned(phi_el_int_0, 16));
                phi_el_stm <= phi_el_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for qv_auto
    qv_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable qv_int_0 : Integer;
        variable qv_temp : std_logic_vector(0 downto 0);

    begin
        -- initialize all outputs to 0
        qv_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to qv_auto)
            if endfile(data_file_ChannelOut) then
                clk_qv_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, qv_int_0);
                qv_temp(0 downto 0) := std_logic_vector(to_unsigned(qv_int_0, 1));
                qv_stm <= qv_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for reset_auto signals
    reset_stm <= (others => '0');
    --Generating stimulus for torque_auto
    torque_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable Torque_int_0 : Integer;
        variable Torque_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        torque_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to torque_auto)
            if endfile(data_file_ChannelIn) then
                clk_torque_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, Torque_int_0);
                Torque_temp(15 downto 0) := std_logic_vector(to_unsigned(Torque_int_0, 16));
                torque_stm <= Torque_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for valid_in_auto
    valid_in_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable valid_in_int_0 : Integer;
        variable valid_in_temp : std_logic_vector(0 downto 0);

    begin
        -- initialize all outputs to 0
        valid_in_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to valid_in_auto)
            if endfile(data_file_ChannelIn) then
                clk_valid_in_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, valid_in_int_0);
                valid_in_temp(0 downto 0) := std_logic_vector(to_unsigned(valid_in_int_0, 1));
                valid_in_stm <= valid_in_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for valid_out_auto
    valid_out_auto_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable valid_out_int_0 : Integer;
        variable valid_out_temp : std_logic_vector(0 downto 0);

    begin
        -- initialize all outputs to 0
        valid_out_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            --(ports connected to valid_out_auto)
            if endfile(data_file_ChannelOut) then
                clk_valid_out_auto_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, dummy_int);
                read(L, dummy_int);
                read(L, valid_out_int_0);
                valid_out_temp(0 downto 0) := std_logic_vector(to_unsigned(valid_out_int_0, 1));
                valid_out_stm <= valid_out_temp;
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);
                read(L, dummy_int);

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;


    clk_stm_sig_stop <= clk_I_Sat_Limit_cfg_auto_stm_sig_stop OR clk_Iu_auto_stm_sig_stop OR clk_Iw_auto_stm_sig_stop OR clk_Ki_cfg_auto_stm_sig_stop OR clk_Kp_cfg_auto_stm_sig_stop OR clk_U_Sat_Limit_cfg_auto_stm_sig_stop OR clk_Valpha_auto_stm_sig_stop OR clk_Vbeta_auto_stm_sig_stop OR clk_axis_in_auto_stm_sig_stop OR clk_axis_out_auto_stm_sig_stop OR clk_debug_1_auto_stm_sig_stop OR clk_debug_2_auto_stm_sig_stop OR clk_debug_3_auto_stm_sig_stop OR clk_dv_auto_stm_sig_stop OR clk_phi_el_auto_stm_sig_stop OR clk_qv_auto_stm_sig_stop OR clk_torque_auto_stm_sig_stop OR clk_valid_in_auto_stm_sig_stop OR clk_valid_out_auto_stm_sig_stop OR '0';

end;
