// DOC_Single_Axis_FE2H_CVE_DOC_Safe_PLL_DC_Link.v

// Generated using ACDS version 13.1 182 at 2014.06.18.15:14:17

`timescale 1 ps / 1 ps
module DOC_Single_Axis_FE2H_CVE_DOC_Safe_PLL_DC_Link (
		input  wire        clk_pll_ref_clk,          //      clk_pll_ref.clk
		input  wire        reset_pll_ref_reset_n,    //    reset_pll_ref.reset_n
		input  wire        dc_link_sync_dat,         //          dc_link.sync_dat
		input  wire        dc_link_dc_link_enable,   //                 .dc_link_enable
		output wire        dc_link_overvoltage,      //                 .overvoltage
		output wire        dc_link_undervoltage,     //                 .undervoltage
		output wire        dc_link_chopper,          //                 .chopper
		output wire        clk_adc_out_clk,          //      clk_adc_out.clk
		output wire        pll_locked_export,        //       pll_locked.export
		output wire        clk_100_out_clk,          //      clk_100_out.clk
		output wire        clk_sdram_out_clk,        //    clk_sdram_out.clk
		output wire        clk_50_out_clk,           //       clk_50_out.clk
		input  wire        clk_adc_in_clk,           //       clk_adc_in.clk
		input  wire        reset_clk_adc_in_reset_n, // reset_clk_adc_in.reset_n
		input  wire        dc_link_avs_write_n,      //      dc_link_avs.write_n
		input  wire        dc_link_avs_read_n,       //                 .read_n
		input  wire [3:0]  dc_link_avs_address,      //                 .address
		input  wire [31:0] dc_link_avs_writedata,    //                 .writedata
		output wire [31:0] dc_link_avs_readdata,     //                 .readdata
		input  wire        clk_50_in_clk,            //        clk_50_in.clk
		input  wire        reset_clk_50_in_reset_n   //  reset_clk_50_in.reset_n
	);

	wire    rst_controller_reset_out_reset;     // rst_controller:reset_out -> pll_0:rst
	wire    rst_controller_001_reset_out_reset; // rst_controller_001:reset_out -> DOC_DC_Link:reset_n

	DOC_Single_Axis_FE2H_CVE_DOC_Safe_PLL_DC_Link_pll_0 pll_0 (
		.refclk   (clk_pll_ref_clk),                //  refclk.clk
		.rst      (rst_controller_reset_out_reset), //   reset.reset
		.outclk_0 (clk_50_out_clk),                 // outclk0.clk
		.outclk_1 (clk_sdram_out_clk),              // outclk1.clk
		.outclk_2 (clk_100_out_clk),                // outclk2.clk
		.outclk_3 (clk_adc_out_clk),                // outclk3.clk
		.locked   (pll_locked_export)               //  locked.export
	);

	ssg_emb_dc_ballast doc_dc_link (
		.clk            (clk_50_in_clk),                       //          clock.clk
		.avs_write_n    (dc_link_avs_write_n),                 // avalon_slave_0.write_n
		.avs_read_n     (dc_link_avs_read_n),                  //               .read_n
		.avs_address    (dc_link_avs_address),                 //               .address
		.avs_writedata  (dc_link_avs_writedata),               //               .writedata
		.avs_readdata   (dc_link_avs_readdata),                //               .readdata
		.reset_n        (~rst_controller_001_reset_out_reset), //          reset.reset_n
		.sync_dat       (dc_link_sync_dat),                    //         status.export
		.dc_link_enable (dc_link_dc_link_enable),              //               .export
		.overvoltage    (dc_link_overvoltage),                 //               .export
		.undervoltage   (dc_link_undervoltage),                //               .export
		.chopper        (dc_link_chopper),                     //               .export
		.clk_adc        (clk_adc_in_clk)                       //      clock_adc.clk
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_pll_ref_reset_n),         // reset_in0.reset
		.clk            (clk_pll_ref_clk),                //       clk.clk
		.reset_out      (rst_controller_reset_out_reset), // reset_out.reset
		.reset_req      (),                               // (terminated)
		.reset_req_in0  (1'b0),                           // (terminated)
		.reset_in1      (1'b0),                           // (terminated)
		.reset_req_in1  (1'b0),                           // (terminated)
		.reset_in2      (1'b0),                           // (terminated)
		.reset_req_in2  (1'b0),                           // (terminated)
		.reset_in3      (1'b0),                           // (terminated)
		.reset_req_in3  (1'b0),                           // (terminated)
		.reset_in4      (1'b0),                           // (terminated)
		.reset_req_in4  (1'b0),                           // (terminated)
		.reset_in5      (1'b0),                           // (terminated)
		.reset_req_in5  (1'b0),                           // (terminated)
		.reset_in6      (1'b0),                           // (terminated)
		.reset_req_in6  (1'b0),                           // (terminated)
		.reset_in7      (1'b0),                           // (terminated)
		.reset_req_in7  (1'b0),                           // (terminated)
		.reset_in8      (1'b0),                           // (terminated)
		.reset_req_in8  (1'b0),                           // (terminated)
		.reset_in9      (1'b0),                           // (terminated)
		.reset_req_in9  (1'b0),                           // (terminated)
		.reset_in10     (1'b0),                           // (terminated)
		.reset_req_in10 (1'b0),                           // (terminated)
		.reset_in11     (1'b0),                           // (terminated)
		.reset_req_in11 (1'b0),                           // (terminated)
		.reset_in12     (1'b0),                           // (terminated)
		.reset_req_in12 (1'b0),                           // (terminated)
		.reset_in13     (1'b0),                           // (terminated)
		.reset_req_in13 (1'b0),                           // (terminated)
		.reset_in14     (1'b0),                           // (terminated)
		.reset_req_in14 (1'b0),                           // (terminated)
		.reset_in15     (1'b0),                           // (terminated)
		.reset_req_in15 (1'b0)                            // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (~reset_clk_50_in_reset_n),           // reset_in0.reset
		.clk            (clk_50_in_clk),                      //       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset), // reset_out.reset
		.reset_req      (),                                   // (terminated)
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_in1      (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

endmodule
