// Copyright (C) 1991-2012 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions 
// and other software and tools, and its AMPP partner logic 
// functions, and any output files from any of the foregoing 
// (including device programming or simulation files), and any 
// associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License 
// Subscription Agreement, Altera MegaCore Function License 
// Agreement, or other applicable license agreement, including, 
// without limitation, that your use is for the sole purpose of 
// programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the 
// applicable agreement for further details.


////////////////////////////////////////////////////////////
// Defines for Register address locations
////////////////////////////////////////////////////////////
// DSPBA_START - Write a 1 to this location to start the calculation
// DSPBA_BUSY - When a 0 is read from this location the calculation has finished
// <NAME>_CFG are configuration registers that are used to store per channel parameters
// <NAME>_CHANNEL is the channel registers. Write the channel number to this register before accessing _CFG registers or starting a calculation
// <NAME>_INPUT are data input registers that are loaded with input data before a calculation is started
// <NAME>_OUTPUT are result registers which are read after a calculation is complete
////////////////////////////////////////////////////////////
#define DSPBA_START 		4
#define DSPBA_BUSY	 		0
#define I_Sat_Limit_cfg_CFG 		64
#define Iu_INPUT 		128
#define Iw_INPUT 		132
#define Ki_cfg_CFG 		68
#define Kp_cfg_CFG 		72
#define U_Sat_Limit_cfg_CFG 		76
#define Valpha_OUTPUT 		192
#define Vbeta_OUTPUT 		196
#define axis_in_CHANNEL 		8
#define phi_el_INPUT 		136
#define reset_INPUT 		140
#define torque_INPUT 		144

void INIT_DSPBA_DOC_Single_Axis_FE2H_CVE_FOC_floating_point_regs (
    int base_address,
	int I_Sat_Limit_cfg_cfg,
	int Ki_cfg_cfg,
	int Kp_cfg_cfg,
	int U_Sat_Limit_cfg_cfg,
	int axis_in_channel
)
{

    IOWR_32DIRECT(base_address,I_Sat_Limit_cfg_CFG, I_Sat_Limit_cfg_cfg);
    IOWR_32DIRECT(base_address,Ki_cfg_CFG, Ki_cfg_cfg);
    IOWR_32DIRECT(base_address,Kp_cfg_CFG, Kp_cfg_cfg);
    IOWR_32DIRECT(base_address,U_Sat_Limit_cfg_CFG, U_Sat_Limit_cfg_cfg);
    IOWR_32DIRECT(base_address,axis_in_CHANNEL, axis_in_channel);
}


static void DSPBA_DOC_Single_Axis_FE2H_CVE_FOC_floating_point_regs (
    int base_address,
    int * timeout_dspba,
    int * axis_out,
	int Iu_input,
	int Iw_input,
	int * Valpha_output,
	int * Vbeta_output,
	int phi_el_input,
	int reset_input,
	int torque_input,
	int axis_in_channel
)
{
	
    int j = 0;

	PERF_BEGIN (PERFORMANCE_COUNTER_BASE, 3);

    PERF_BEGIN (PERFORMANCE_COUNTER_BASE, 2);

    IOWR_32DIRECT(base_address,axis_in_CHANNEL, axis_in_channel);

    //Load input data
	IOWR_32DIRECT(base_address,Iu_INPUT, Iu_input);
	IOWR_32DIRECT(base_address,Iw_INPUT, Iw_input);
	IOWR_32DIRECT(base_address,phi_el_INPUT, phi_el_input);
	IOWR_32DIRECT(base_address,reset_INPUT, reset_input);
	IOWR_32DIRECT(base_address,torque_INPUT, torque_input);

	//Load start bit
	IOWR_32DIRECT(base_address,DSPBA_START,1);

	PERF_BEGIN (PERFORMANCE_COUNTER_BASE, 2);

	//Read finished bit - wait until it changes from last time
	j=0;
	int status_out = 1;
	while ((status_out != 0) & (j<100)) {
	  status_out = IORD_32DIRECT(base_address, DSPBA_BUSY);
	  j++;
	}
	if (j==100) *timeout_dspba = 1;

	PERF_END (PERFORMANCE_COUNTER_BASE, 2);

	*timeout_dspba = j;

	//Read integer output data

	* Valpha_output = IORD_32DIRECT(base_address, Valpha_OUTPUT );
	* Vbeta_output = IORD_32DIRECT(base_address, Vbeta_OUTPUT );

	PERF_END (PERFORMANCE_COUNTER_BASE, 3);

}


