// Copyright (C) 1991-2012 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions 
// and other software and tools, and its AMPP partner logic 
// functions, and any output files from any of the foregoing 
// (including device programming or simulation files), and any 
// associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License 
// Subscription Agreement, Altera MegaCore Function License 
// Agreement, or other applicable license agreement, including, 
// without limitation, that your use is for the sole purpose of 
// programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the 
// applicable agreement for further details.


`timescale 1ns/1ns
// DOC_Single_Axis_FE2H_CVE_FOC_floating_point_regs 
//module my_dspba_regs (
module DOC_Single_Axis_FE2H_CVE_FOC_floating_point_regs (
	input           clk,
	input           reset_n,

	// Input & output signals for connection to Avalon register map
    output  [31:0] I_Sat_Limit_cfg,
    output reg [31:0] Iu,
    output reg [31:0] Iw,
    output  [31:0] Ki_cfg,
    output  [31:0] Kp_cfg,
    output  [31:0] U_Sat_Limit_cfg,
    input  [31:0] Valpha,
    input  [31:0] Vbeta,
    output reg [7:0] axis_in,
    input  [7:0] axis_out,
    input  [15:0] debug_1,
    input  [15:0] debug_2,
    input  [15:0] debug_3,
    output reg dv,
    output reg [15:0] phi_el,
    input  qv,
    output reg reset,
    output reg [31:0] torque,
    output reg valid_in,
    input  valid_out,


	// Input & output signals to be exported from DSPBA model
	// Not connected to Avalon register map
    output [15:0] debug_1_exp,
    output [15:0] debug_2_exp,
    output [15:0] debug_3_exp,


    // Avalon-MM in system clk domain
	input               avs_write_n,
	input               avs_read_n,
	input [7:0]         avs_address,
	input [31:0]        avs_writedata,
	output reg [31:0]   avs_readdata,
	output reg          avs_readdatavalid,
	output reg          avs_waitrequest

	
);											


// {I_Sat_Limit_cfg output 32 cfg 16} {Iu output 32 in 32} {Iw output 32 in 33} {Ki_cfg output 32 cfg 17} {Kp_cfg output 32 cfg 18} {U_Sat_Limit_cfg output 32 cfg 19} {Valpha input 32 out 48} {Vbeta input 32 out 49} {axis_in output 8 channel_in 2} {axis_out input 8 channel_out 0} {debug_1 input 16 ignore 0} {debug_2 input 16 ignore 0} {debug_3 input 16 ignore 0} {dv output 1 dv 0} {phi_el output 16 in 34} {qv input 1 qv 0} {reset output 1 in 35} {torque output 32 in 36} {valid_in output 1 valid_in 0} {valid_out input 1 valid_out 0}


//Set from hw.tcl
parameter FOLDING_FACTOR = 1;


// Defintion of regs for storage of Avalon register values
// One per input or output register
// Config registers are per channel (array of config registers)
reg [31:0] I_Sat_Limit_cfg_reg[ 3:0];
reg [31:0] Ki_cfg_reg[ 3:0];
reg [31:0] Kp_cfg_reg[ 3:0];
reg [31:0] U_Sat_Limit_cfg_reg[ 3:0];
reg [31:0] Valpha_reg[ 3:0];
reg [31:0] Vbeta_reg[ 3:0];
reg [7:0] axis_in_reg;
reg [7:0] axis_out_reg;
reg [15:0] debug_1_reg;
reg [15:0] debug_2_reg;
reg [15:0] debug_3_reg;
reg dv_reg;
reg qv_reg;
reg valid_in_reg;
reg valid_out_reg;


reg [15:0] conf;

reg [15:0] dv_counter;

reg	[3:0]	busy;
reg			start_reg;
reg			reset_start;

// Signals not connected to Avalon register map are directly exported (passed through)
    assign debug_1_exp = debug_1;
    assign debug_2_exp = debug_2;
    assign debug_3_exp = debug_3;

// Signals not connected to Avalon register map are directly exported (passed through)
    assign I_Sat_Limit_cfg = I_Sat_Limit_cfg_reg[axis_in];
    assign Ki_cfg = Ki_cfg_reg[axis_in];
    assign Kp_cfg = Kp_cfg_reg[axis_in];
    assign U_Sat_Limit_cfg = U_Sat_Limit_cfg_reg[axis_in];


// --------------------------------------------------------------------------
// Avalon write registers
// --------------------------------------------------------------------------
// Simple address decode to store data in addressed register
// Config registers are stored in an array indexed by channel number 
// --------------------------------------------------------------------------
always @(posedge clk or negedge reset_n)
    if (~reset_n)
    begin
//		busy_reg <= 0;
		start_reg <= 1'b0;		
		I_Sat_Limit_cfg_reg[0] <= 32'b0;
		I_Sat_Limit_cfg_reg[1] <= 32'b0;
		I_Sat_Limit_cfg_reg[2] <= 32'b0;
		I_Sat_Limit_cfg_reg[3] <= 32'b0;
		Iu <= 32'b0;
		Iw <= 32'b0;
		Ki_cfg_reg[0] <= 32'b0;
		Ki_cfg_reg[1] <= 32'b0;
		Ki_cfg_reg[2] <= 32'b0;
		Ki_cfg_reg[3] <= 32'b0;
		Kp_cfg_reg[0] <= 32'b0;
		Kp_cfg_reg[1] <= 32'b0;
		Kp_cfg_reg[2] <= 32'b0;
		Kp_cfg_reg[3] <= 32'b0;
		U_Sat_Limit_cfg_reg[0] <= 32'b0;
		U_Sat_Limit_cfg_reg[1] <= 32'b0;
		U_Sat_Limit_cfg_reg[2] <= 32'b0;
		U_Sat_Limit_cfg_reg[3] <= 32'b0;
		axis_in <= 8'b0;
		phi_el <= 16'b0;
		reset <= 1'b0;
		torque <= 32'b0;
    end
    else
	begin
		if (~avs_write_n)
		begin
			case (avs_address)
//				8'd00:   busy_reg <= avs_writedata[0]; //read only
				8'd01:   start_reg <= avs_writedata[0];
				8'd16: I_Sat_Limit_cfg_reg[axis_in] <= avs_writedata[31:0];
				8'd32: Iu <= avs_writedata[31:0];
				8'd33: Iw <= avs_writedata[31:0];
				8'd17: Ki_cfg_reg[axis_in] <= avs_writedata[31:0];
				8'd18: Kp_cfg_reg[axis_in] <= avs_writedata[31:0];
				8'd19: U_Sat_Limit_cfg_reg[axis_in] <= avs_writedata[31:0];
				8'd2: axis_in <= avs_writedata[7:0];
				8'd34: phi_el <= avs_writedata[15:0];
				8'd35: reset <= avs_writedata[0:0];
				8'd36: torque <= avs_writedata[31:0];
			endcase
		end
		if (reset_start)
			start_reg <= 1'b0;
	end
	
// --------------------------------------------------------------------------
// Avalon read registers
// --------------------------------------------------------------------------
// Output from DSPBA model are latched when QV & Valid_in inputs are both high
// --------------------------------------------------------------------------
always @(posedge clk or negedge reset_n)
    if (~reset_n)
    begin
		Valpha_reg[0] <= 32'b0;
		Valpha_reg[1] <= 32'b0;
		Valpha_reg[2] <= 32'b0;
		Valpha_reg[3] <= 32'b0;
		Vbeta_reg[0] <= 32'b0;
		Vbeta_reg[1] <= 32'b0;
		Vbeta_reg[2] <= 32'b0;
		Vbeta_reg[3] <= 32'b0;
    end
    else if ((qv == 1'b1) &&(valid_out == 1'b1))
    begin
		Valpha_reg[axis_out] <= Valpha;
		Vbeta_reg[axis_out] <= Vbeta;
    end


// --------------------------------------------------------------------------
// DSPBA Folding Counter
// --------------------------------------------------------------------------
// Counts from 0 to FOLDING_FACTOR-1 after reset. 
// When the counter is 0 dv is set to 1. When valid_in is 1 at the same time
// as dv = 1 new data is processed by DSPBA.
// --------------------------------------------------------------------------

always @(posedge clk or negedge reset_n)
begin : foldcount_blk
	reg inc_busy, dec_busy;
	if (~reset_n)
	begin
		dv_counter <= 16'b0;
		busy <= 4'b0;
		valid_in <= 1'b0;
		reset_start <= 1'b0;
		dv <= 1'b0;
	end
	else
	begin
		reset_start <= 1'b0;

		if (dv_counter == FOLDING_FACTOR-1)
			dv_counter <= 0;
		else
			dv_counter <= dv_counter+1'b1;
		if (dv_counter == 0)
		begin
			dv <= 1'b1;
		end
		else
			dv <= 1'b0;			

		inc_busy = 1'b0;
		dec_busy = 1'b0;	
		if ((qv == 1'b1) && (valid_out == 1'b1))
			dec_busy = 1'b1;

		if (start_reg)
			valid_in <= 1'b1;
		if (reset_start)
			valid_in <= 1'b0;

			
		if ((dv == 1'b1) && (valid_in == 1'b1))
		begin
			reset_start <= 1'b1;
		end
		if ((start_reg == 1'b1) && (valid_in == 1'b0))
		begin
			inc_busy = 1'b1;
		end
		case ({inc_busy,dec_busy})
			2'b00 : busy <= busy;
			2'b11 : busy <= busy;
			2'b01 : busy <= busy - 1'b1;
			2'b10 : busy <= busy + 1'b1;
			default : busy <= busy;
		endcase
	end
end

	
	
// --------------------------------------------------------------------------
// Avalon read data mux
// --------------------------------------------------------------------------
// Responds to read commands to decode the address and provide the rddata output
// Will use readdatavalid to provide variable latency reads.
// Reads from the 'result' registers will occur with a fixed latency
// However reads from the 'ready' register may be held off until the data is
// actually ready (wait for qv)
// --------------------------------------------------------------------------
always @(posedge clk or negedge reset_n)
begin : rddata_blk
	reg [31:0] readdata;
	readdata = 32'b0;
	if (~reset_n)
    begin
        avs_readdata <= 32'b0;
		avs_readdatavalid <= 1'b0;
		avs_waitrequest <= 1'b0;
    end
    else
	begin
		avs_waitrequest <= 1'b0;  // Not used for now!
		if (~avs_read_n)
		begin
			readdata = 0;
			case (avs_address)
				8'd00:   readdata[3:0]   = busy;
				8'd01:   readdata[0]   = start_reg;
				8'd16:   readdata[31:0] = I_Sat_Limit_cfg_reg[axis_in];
				8'd32:   readdata[31:0] = Iu;
				8'd33:   readdata[31:0] = Iw;
				8'd17:   readdata[31:0] = Ki_cfg_reg[axis_in];
				8'd18:   readdata[31:0] = Kp_cfg_reg[axis_in];
				8'd19:   readdata[31:0] = U_Sat_Limit_cfg_reg[axis_in];
				8'd48:   readdata[31:0] = Valpha_reg[axis_in];
//				8'd48:   readdata[31:0] = Valpha_reg;
				8'd49:   readdata[31:0] = Vbeta_reg[axis_in];
//				8'd49:   readdata[31:0] = Vbeta_reg;
				8'd2:   readdata[7:0] = axis_in;
				8'd34:   readdata[15:0] = phi_el;
				8'd35:   readdata[0:0] = reset;
				8'd36:   readdata[31:0] = torque;
			endcase
			avs_readdata <= readdata;
			avs_readdatavalid <= 1'b1;
		end
		else
		begin
			avs_readdatavalid <= 1'b0;
		end
	end
end

endmodule   // dspba_regs


