// DOC_Single_Axis_FE2H_CVE_drive0.v

// Generated using ACDS version 13.1 182 at 2014.06.18.15:14:14

`timescale 1 ps / 1 ps
module DOC_Single_Axis_FE2H_CVE_drive0 (
		input  wire        clk_adc_clk,               //          clk_adc.clk
		input  wire        reset_reset_n,             //            reset.reset_n
		input  wire        clk_periph_clk,            //       clk_periph.clk
		input  wire        reset_periph_reset_n,      //     reset_periph.reset_n
		input  wire        doc_adc_avs_write_n,       //      doc_adc_avs.write_n
		input  wire        doc_adc_avs_read_n,        //                 .read_n
		input  wire [3:0]  doc_adc_avs_address,       //                 .address
		input  wire [31:0] doc_adc_avs_writedata,     //                 .writedata
		output wire [31:0] doc_adc_avs_readdata,      //                 .readdata
		output wire        doc_adc_irq_irq,           //      doc_adc_irq.irq
		input  wire        doc_pwm_avs_write_n,       //      doc_pwm_avs.write_n
		input  wire        doc_pwm_avs_read_n,        //                 .read_n
		input  wire [3:0]  doc_pwm_avs_address,       //                 .address
		input  wire [31:0] doc_pwm_avs_writedata,     //                 .writedata
		output wire [31:0] doc_pwm_avs_readdata,      //                 .readdata
		input  wire        doc_sm_avs_write_n,        //       doc_sm_avs.write_n
		input  wire        doc_sm_avs_read_n,         //                 .read_n
		input  wire        doc_sm_avs_address,        //                 .address
		input  wire [31:0] doc_sm_avs_writedata,      //                 .writedata
		output wire [31:0] doc_sm_avs_readdata,       //                 .readdata
		input  wire        doc_adc_pow_avs_write_n,   //  doc_adc_pow_avs.write_n
		input  wire        doc_adc_pow_avs_read_n,    //                 .read_n
		input  wire [3:0]  doc_adc_pow_avs_address,   //                 .address
		input  wire [31:0] doc_adc_pow_avs_writedata, //                 .writedata
		output wire [31:0] doc_adc_pow_avs_readdata,  //                 .readdata
		output wire        doc_adc_pow_irq_irq,       //  doc_adc_pow_irq.irq
		output wire        doc_pwm_sync_out_export,   // doc_pwm_sync_out.export
		input  wire        doc_pwm_sync_in_export,    //  doc_pwm_sync_in.export
		input  wire        adc_pow_sync_dat_u,        //          adc_pow.sync_dat_u
		input  wire        adc_pow_sync_dat_w,        //                 .sync_dat_w
		output wire        adc_pow_overcurrent,       //                 .overcurrent
		input  wire        adc_sync_dat_u,            //              adc.sync_dat_u
		input  wire        adc_sync_dat_w,            //                 .sync_dat_w
		output wire        adc_overcurrent,           //                 .overcurrent
		output wire [15:0] pwm_carrier,               //              pwm.carrier
		output wire        pwm_carrier_latch,         //                 .carrier_latch
		output wire        pwm_encoder_strobe_n,      //                 .encoder_strobe_n
		output wire        pwm_u_h,                   //                 .u_h
		output wire        pwm_u_l,                   //                 .u_l
		output wire        pwm_v_h,                   //                 .v_h
		output wire        pwm_v_l,                   //                 .v_l
		output wire        pwm_w_h,                   //                 .w_h
		output wire        pwm_w_l,                   //                 .w_l
		input  wire        sm_overcurrent,            //               sm.overcurrent
		input  wire        sm_overvoltage,            //                 .overvoltage
		input  wire        sm_undervoltage,           //                 .undervoltage
		input  wire        sm_chopper,                //                 .chopper
		input  wire        sm_dc_link_clk_err,        //                 .dc_link_clk_err
		input  wire        sm_igbt_err,               //                 .igbt_err
		output wire        sm_error_out,              //                 .error_out
		output wire        sm_overcurrent_latch,      //                 .overcurrent_latch
		output wire        sm_overvoltage_latch,      //                 .overvoltage_latch
		output wire        sm_undervoltage_latch,     //                 .undervoltage_latch
		output wire        sm_dc_link_clk_err_latch,  //                 .dc_link_clk_err_latch
		output wire        sm_igbt_err_latch,         //                 .igbt_err_latch
		output wire        sm_chopper_latch           //                 .chopper_latch
	);

	wire  [2:0] doc_sm_pwm_control_export;                  // DOC_SM:pwm_control -> DOC_PWM:pwm_control
	wire        doc_pwm_start_adc_export;                   // DOC_PWM:start_adc -> conduit_splitter_0:conduit_input
	wire        conduit_splitter_0_conduit_output_0_export; // conduit_splitter_0:conduit_output_0 -> DOC_ADC:start
	wire        conduit_splitter_0_conduit_output_1_export; // conduit_splitter_0:conduit_output_1 -> DOC_ADC_POW:start
	wire        rst_controller_reset_out_reset;             // rst_controller:reset_out -> [DOC_ADC:reset_n, DOC_ADC_POW:reset_n, DOC_PWM:reset_n, DOC_SM:reset_n]

	ssg_emb_sd_adc doc_adc (
		.clk           (clk_periph_clk),                             //        clock.clk
		.reset_n       (~rst_controller_reset_out_reset),            //        reset.reset_n
		.avs_irq       (doc_adc_irq_irq),                            //          irq.irq
		.avs_write_n   (doc_adc_avs_write_n),                        // avalon_slave.write_n
		.avs_read_n    (doc_adc_avs_read_n),                         //             .read_n
		.avs_address   (doc_adc_avs_address),                        //             .address
		.avs_writedata (doc_adc_avs_writedata),                      //             .writedata
		.avs_readdata  (doc_adc_avs_readdata),                       //             .readdata
		.clk_adc       (clk_adc_clk),                                //    clock_adc.clk
		.sync_dat_u    (adc_sync_dat_u),                             //          adc.export
		.sync_dat_w    (adc_sync_dat_w),                             //             .export
		.overcurrent   (adc_overcurrent),                            //             .export
		.start         (conduit_splitter_0_conduit_output_0_export)  //        start.export
	);

	ssg_emb_pwm doc_pwm (
		.clk              (clk_periph_clk),                  //          clock.clk
		.reset_n          (~rst_controller_reset_out_reset), //          reset.reset_n
		.avs_write_n      (doc_pwm_avs_write_n),             // avalon_slave_0.write_n
		.avs_read_n       (doc_pwm_avs_read_n),              //               .read_n
		.avs_address      (doc_pwm_avs_address),             //               .address
		.avs_writedata    (doc_pwm_avs_writedata),           //               .writedata
		.avs_readdata     (doc_pwm_avs_readdata),            //               .readdata
		.carrier          (pwm_carrier),                     //            pwm.export
		.carrier_latch    (pwm_carrier_latch),               //               .export
		.encoder_strobe_n (pwm_encoder_strobe_n),            //               .export
		.u_h              (pwm_u_h),                         //               .export
		.u_l              (pwm_u_l),                         //               .export
		.v_h              (pwm_v_h),                         //               .export
		.v_l              (pwm_v_l),                         //               .export
		.w_h              (pwm_w_h),                         //               .export
		.w_l              (pwm_w_l),                         //               .export
		.sync_out         (doc_pwm_sync_out_export),         //       sync_out.export
		.start_adc        (doc_pwm_start_adc_export),        //      start_adc.export
		.sync_in          (doc_pwm_sync_in_export),          //        sync_in.export
		.pwm_control      (doc_sm_pwm_control_export)        //    pwm_control.export
	);

	ssg_emb_dsm #(
		.init        (4'b0000),
		.prech       (4'b0001),
		.prer        (4'b0010),
		.run         (4'b0011),
		.error       (4'b0100),
		.pwm_disable (4'b0000),
		.pwm_enable  (4'b0001),
		.pwm_lower   (4'b0011),
		.pwm_both    (4'b0111)
	) doc_sm (
		.clk                   (clk_periph_clk),                  //          clock.clk
		.reset_n               (~rst_controller_reset_out_reset), //          reset.reset_n
		.avs_write_n           (doc_sm_avs_write_n),              // avalon_slave_0.write_n
		.avs_read_n            (doc_sm_avs_read_n),               //               .read_n
		.avs_address           (doc_sm_avs_address),              //               .address
		.avs_writedata         (doc_sm_avs_writedata),            //               .writedata
		.avs_readdata          (doc_sm_avs_readdata),             //               .readdata
		.overcurrent           (sm_overcurrent),                  //        monitor.export
		.overvoltage           (sm_overvoltage),                  //               .export
		.undervoltage          (sm_undervoltage),                 //               .export
		.chopper               (sm_chopper),                      //               .export
		.dc_link_clk_err       (sm_dc_link_clk_err),              //               .export
		.igbt_err              (sm_igbt_err),                     //               .export
		.error_out             (sm_error_out),                    //               .export
		.overcurrent_latch     (sm_overcurrent_latch),            //               .export
		.overvoltage_latch     (sm_overvoltage_latch),            //               .export
		.undervoltage_latch    (sm_undervoltage_latch),           //               .export
		.dc_link_clk_err_latch (sm_dc_link_clk_err_latch),        //               .export
		.igbt_err_latch        (sm_igbt_err_latch),               //               .export
		.chopper_latch         (sm_chopper_latch),                //               .export
		.pwm_control           (doc_sm_pwm_control_export)        //    pwm_control.export
	);

	ssg_emb_sd_adc doc_adc_pow (
		.clk           (clk_periph_clk),                             //        clock.clk
		.reset_n       (~rst_controller_reset_out_reset),            //        reset.reset_n
		.avs_irq       (doc_adc_pow_irq_irq),                        //          irq.irq
		.avs_write_n   (doc_adc_pow_avs_write_n),                    // avalon_slave.write_n
		.avs_read_n    (doc_adc_pow_avs_read_n),                     //             .read_n
		.avs_address   (doc_adc_pow_avs_address),                    //             .address
		.avs_writedata (doc_adc_pow_avs_writedata),                  //             .writedata
		.avs_readdata  (doc_adc_pow_avs_readdata),                   //             .readdata
		.clk_adc       (clk_adc_clk),                                //    clock_adc.clk
		.sync_dat_u    (adc_pow_sync_dat_u),                         //          adc.export
		.sync_dat_w    (adc_pow_sync_dat_w),                         //             .export
		.overcurrent   (adc_pow_overcurrent),                        //             .export
		.start         (conduit_splitter_0_conduit_output_1_export)  //        start.export
	);

	conduit_splitter #(
		.OUTPUT_NUM (2)
	) conduit_splitter_0 (
		.conduit_input    (doc_pwm_start_adc_export),                   //    conduit_input.export
		.conduit_output_0 (conduit_splitter_0_conduit_output_0_export), // conduit_output_0.export
		.conduit_output_1 (conduit_splitter_0_conduit_output_1_export)  // conduit_output_1.export
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_periph_reset_n),          // reset_in0.reset
		.clk            (clk_periph_clk),                 //       clk.clk
		.reset_out      (rst_controller_reset_out_reset), // reset_out.reset
		.reset_req      (),                               // (terminated)
		.reset_req_in0  (1'b0),                           // (terminated)
		.reset_in1      (1'b0),                           // (terminated)
		.reset_req_in1  (1'b0),                           // (terminated)
		.reset_in2      (1'b0),                           // (terminated)
		.reset_req_in2  (1'b0),                           // (terminated)
		.reset_in3      (1'b0),                           // (terminated)
		.reset_req_in3  (1'b0),                           // (terminated)
		.reset_in4      (1'b0),                           // (terminated)
		.reset_req_in4  (1'b0),                           // (terminated)
		.reset_in5      (1'b0),                           // (terminated)
		.reset_req_in5  (1'b0),                           // (terminated)
		.reset_in6      (1'b0),                           // (terminated)
		.reset_req_in6  (1'b0),                           // (terminated)
		.reset_in7      (1'b0),                           // (terminated)
		.reset_req_in7  (1'b0),                           // (terminated)
		.reset_in8      (1'b0),                           // (terminated)
		.reset_req_in8  (1'b0),                           // (terminated)
		.reset_in9      (1'b0),                           // (terminated)
		.reset_req_in9  (1'b0),                           // (terminated)
		.reset_in10     (1'b0),                           // (terminated)
		.reset_req_in10 (1'b0),                           // (terminated)
		.reset_in11     (1'b0),                           // (terminated)
		.reset_req_in11 (1'b0),                           // (terminated)
		.reset_in12     (1'b0),                           // (terminated)
		.reset_req_in12 (1'b0),                           // (terminated)
		.reset_in13     (1'b0),                           // (terminated)
		.reset_req_in13 (1'b0),                           // (terminated)
		.reset_in14     (1'b0),                           // (terminated)
		.reset_req_in14 (1'b0),                           // (terminated)
		.reset_in15     (1'b0),                           // (terminated)
		.reset_req_in15 (1'b0)                            // (terminated)
	);

endmodule
