// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions 
// and other software and tools, and its AMPP partner logic 
// functions, and any output files from any of the foregoing 
// (including device programming or simulation files), and any 
// associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License 
// Subscription Agreement, Altera MegaCore Function License 
// Agreement, or other applicable license agreement, including, 
// without limitation, that your use is for the sole purpose of 
// programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the 
// applicable agreement for further details.


module DOC_top (
	input wire	clk_50,
	
	input  wire clk_125,
	
	input wire	[`NUM_BUTTONS-1:0] button,
	output wire	[`NUM_LEDS-1:0] LED,
		
	//ADC
   input wire	drive0_adc_Sync_Dat_U,
   input wire	drive0_adc_Sync_Dat_W,

	// IGBT Control
   output wire	drive0_pwm_u_h,
   output wire	drive0_pwm_u_l,
   output wire	drive0_pwm_v_h,
   output wire	drive0_pwm_v_l,
   output wire	drive0_pwm_w_h,
   output wire	drive0_pwm_w_l,
   input wire	drive0_sm_igbt_err,


   output wire	sys_braking,
   input wire	dc_link_Sync_Dat_VBUS,
		 
	output wire	IU_Clk,
	output wire	IW_Clk,
	output wire	VBus_Clk,

	output wire [`FLASH_ADDR_MSB:0] flash_a,
	output wire flash_cen,
	output wire flash_oen,
	output wire flash_wen,
	inout  wire [`FLASH_DATA_WIDTH-1:0] flash_d,
		
// Device/board specific flash pins
	output wire        flash_resetn,
	output wire        flash_advn,
	output wire        flash_clk,

	// TODO: Rationalise DDR3 signal names as they are largely the same apart from widths

	// CV E/GX dev kit HMC DDR3 pins
	output wire [13:0] ddr3_fpga_a,
	output wire [2:0]  ddr3_fpga_ba,
	output wire [0:0]  ddr3_fpga_ck,
	output wire [0:0]  ddr3_fpga_ck_n,
	output wire [0:0]  ddr3_fpga_cke,
	output wire [0:0]  ddr3_fpga_cs_n,
	output wire [0:0]  ddr3_fpga_dm,
	output wire [0:0]  ddr3_fpga_ras_n,
	output wire [0:0]  ddr3_fpga_cas_n,
	output wire [0:0]  ddr3_fpga_we_n,
	output wire        ddr3_fpga_reset_n,
	inout  wire [7:0]  ddr3_fpga_dq,
	inout  wire [0:0]  ddr3_fpga_dqs,
	inout  wire [0:0]  ddr3_fpga_dqs_n,
	output wire [0:0]  ddr3_fpga_odt,
	input  wire        ddr3_fpga_oct_rzqin

);

wire reset_in;
assign reset_in = 1'b0;

assign ddr3_fpga_a[13] = 1'b0;		//tie off highest order address bit (unused) - restrict the memory space in Qsys


// System
wire	reset_n = ~reset_in & pll_locked;
wire	pll_locked;
wire	clk_adc;


// Flash/SRAM configuration
// Map output pins to Qsys component. Virtual pin asignments must are added for unused flash
// addresses where (FLASH_ADDR_LSB > 0)
wire [`FLASH_ADDR_MSB:0] flash_addr;
assign flash_a[`FLASH_ADDR_MSB:`FLASH_ADDR_LSB] = flash_addr[`FLASH_ADDR_MSB:`FLASH_ADDR_LSB];


assign flash_a[0]   = 1'b0;		// virtual pin
//Safety assign flash_resetn = reset_n;
assign flash_resetn = 1'b1;
assign flash_advn   = 1'b0;
assign flash_clk    = 1'b0;



// DC Link
wire	Chopper;
wire	Overvoltage;
wire	Undervoltage;

// ADC

assign IU_Clk = clk_adc;
assign IW_Clk = clk_adc;
assign VBus_Clk = clk_adc;


wire	Overcurrent0;


// PWM
wire	[3:0] control;

wire drive0_igbt_err_in;

// Already inverted by opto-couplers on FalconEye
assign drive0_igbt_err_in = drive0_sm_igbt_err;


wire	enc_stb0_n;
wire	pwm0_u_h;
wire	pwm0_u_l;
wire	pwm0_v_h;
wire	pwm0_v_l;
wire	pwm0_w_h;
wire	pwm0_w_l;

// Compensate for inversion in opto-couplers on FalconEye board
assign	drive0_pwm_u_h =  ~pwm0_u_h;
assign	drive0_pwm_u_l =  ~pwm0_u_l;
assign	drive0_pwm_v_h =  ~pwm0_v_h;
assign	drive0_pwm_v_l =  ~pwm0_v_l;
assign	drive0_pwm_w_h =  ~pwm0_w_h;
assign	drive0_pwm_w_l =  ~pwm0_w_l;

// Connect state outputs to LEDs
wire	Err_Out0;
wire	oc_latch_led0;
wire	ov_latch_led0;
wire	uv_latch_led0;
wire	igbt_err_led0;
wire	chopper_led0;


wire	oc_latch_led1;
wire	oc_latch_led2;
wire	oc_latch_led3;
// Assign LEDs on CVE board
assign LED[0] =  oc_latch_led0;


assign	sys_braking = ~Chopper | Err_Out0;

wire test_irq;

`QSYS_INSTANCE u_doc (

	.reset_n_reset_n	(reset_n),

	.clk_125_clk		(clk_125),

	.clk_50_in_clk			(clk_50),
   .pll_locked_export	(pll_locked),


//		.pll_0_reset_reset	(1'b0),
		.pll_0_reset_reset_n	(1'b1),
	
   .clk_adc_out_clk     (clk_adc),

	.clk_adc_in_clk (clk_adc),
	
	.in_port_to_the_IO_IN_Buttons       (button),
	

	.dc_link_sync_dat          (dc_link_Sync_Dat_VBUS),

	.dc_link_dc_link_enable    (1'b1),
	.dc_link_overvoltage       (Overvoltage),
	.dc_link_undervoltage      (Undervoltage),
	.dc_link_chopper           (Chopper),

	
	.sync_in_export				(1'b0),
	
	// ADC bit streams are inverted to correct fot FalconEye polarity
	.drive0_adc_sync_dat_u   (~drive0_adc_Sync_Dat_U),
	.drive0_adc_sync_dat_w   (~drive0_adc_Sync_Dat_W),

	.drive0_adc_overcurrent  (Overcurrent0),
	
	.drive0_adc_pow_sync_dat_u       (1'b0),

	.drive0_adc_pow_sync_dat_w       (1'b0),
	.drive0_adc_pow_overcurrent      (),

 	.drive0_sm_overcurrent               (Overcurrent0),	// i/p
	.drive0_sm_overvoltage               (Overvoltage),	// i/p
	.drive0_sm_undervoltage              (Undervoltage),	// i/p
	.drive0_sm_chopper                   (Chopper),			// i/p
	.drive0_sm_dc_link_clk_err           (1'b0),	// i/p
	.drive0_sm_igbt_err                  (drive0_igbt_err_in),		// i/p
	.drive0_sm_error_out                 (Err_Out0),			// o/p
	.drive0_sm_overcurrent_latch         (oc_latch_led0),	// o/p
	.drive0_sm_overvoltage_latch         (ov_latch_led0),	// o/p
	.drive0_sm_undervoltage_latch        (uv_latch_led0),	// o/p
	.drive0_sm_dc_link_clk_err_latch     (),	// o/p
	.drive0_sm_igbt_err_latch            (igbt_err_led0),	// o/p
	.drive0_sm_chopper_latch             (chopper_led0),	// o/p
	
	.drive0_pwm_carrier          (),
	.drive0_pwm_carrier_latch    (),
	.drive0_pwm_encoder_strobe_n (enc_stb0_n),
	.drive0_pwm_u_h              (pwm0_u_h),
	.drive0_pwm_u_l              (pwm0_u_l),
	.drive0_pwm_v_h              (pwm0_v_h),
	.drive0_pwm_v_l              (pwm0_v_l),
	.drive0_pwm_w_h              (pwm0_w_h),
	.drive0_pwm_w_l              (pwm0_w_l),



	.tri_state_bridge_address    (flash_addr),
	.tri_state_bridge_readn      (flash_oen),
	.tri_state_bridge_writen     (flash_wen),
	.select_n_to_the_cfi_flash   (flash_cen),
	.tri_state_bridge_data       (flash_d),

	
	// CV E dev kit HMC DDR3 interface
	.ddr3_fpga_mem_a                     (ddr3_fpga_a[12:0]),
	.ddr3_fpga_mem_ba                    (ddr3_fpga_ba),
	.ddr3_fpga_mem_ck                    (ddr3_fpga_ck),
	.ddr3_fpga_mem_ck_n                  (ddr3_fpga_ck_n),
	.ddr3_fpga_mem_cke                   (ddr3_fpga_cke),
	.ddr3_fpga_mem_cs_n                  (ddr3_fpga_cs_n),
	.ddr3_fpga_mem_dm                    (ddr3_fpga_dm),
	.ddr3_fpga_mem_ras_n                 (ddr3_fpga_ras_n),
	.ddr3_fpga_mem_cas_n                 (ddr3_fpga_cas_n),
	.ddr3_fpga_mem_we_n                  (ddr3_fpga_we_n),
	.ddr3_fpga_mem_reset_n               (ddr3_fpga_reset_n),
	.ddr3_fpga_mem_dq                    (ddr3_fpga_dq),
	.ddr3_fpga_mem_dqs                   (ddr3_fpga_dqs),
	.ddr3_fpga_mem_dqs_n                 (ddr3_fpga_dqs_n),
	.ddr3_fpga_mem_odt                   (ddr3_fpga_odt),
	.ddr3_fpga_oct_rzqin                 (ddr3_fpga_oct_rzqin)

);

endmodule
