# This script must be run after uniphy scripts

derive_pll_clocks
derive_clock_uncertainty

# False paths for asynch resets into MPFE
set_false_path -through [get_pins -compatibility_mode *reset_controller_0*] -to [get_clocks {u_doc|ddr3_fpga|pll0|pll_afi_clk}]
set_false_path -through [get_pins -compatibility_mode *reset_controller_0*] -to [get_clocks {u_doc|ddr3_fpga|pll0|pll_addr_cmd_clk}]
set_false_path -through [get_pins -compatibility_mode *reset_controller_0*] -to [get_clocks {u_doc|ddr3_fpga|pll0|pll_avl_clk}]

#doc_safe_pll_dc_link	
#DOC_Single_Axis_FE2H_CVE_DOC_Safe_PLL_DC_Link_pll_0:pll_0	
#altera_pll:altera_pll_i	

# Model external delays on ADC data
set_input_delay -add_delay -max -clock [get_clocks {u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[3].gpll~PLL_OUTPUT_COUNTER|divclk}]  37.0 [get_ports {*_Sync_Dat_*}]
set_input_delay -add_delay -min -clock [get_clocks {u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[3].gpll~PLL_OUTPUT_COUNTER|divclk}]   5.8 [get_ports {*_Sync_Dat_*}]

# False paths for asynch clk_adc
set_false_path -from [get_clocks {u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}] -to [get_clocks {u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[3].gpll~PLL_OUTPUT_COUNTER|divclk}]
set_false_path -from [get_clocks {u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[3].gpll~PLL_OUTPUT_COUNTER|divclk}] -to [get_clocks {u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk}]


# I/O false paths
set_false_path -to [get_ports *LED\[*\]*]
set_false_path -to [get_ports *sys_adc_clk]
set_false_path -to [get_ports *sys_pfc_*]
set_false_path -from [get_ports *button\[*\]*]
set_false_path -from [get_ports *drive*_sm_igbt_err*]
set_false_path -from [get_ports *sys_pfc_*]
set_output_delay -clock { u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 5 [get_ports *drive*pwm*]
set_output_delay -clock { u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 8 [get_ports *flash*]
set_input_delay -clock { u_doc|doc_safe_pll_dc_link|pll_0|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk } 10 [get_ports *flash_d*]
