# define the system clock

create_clock -period 20 -name inclk_IN [get_ports {clk_50}]

## Cutting paths between the JTAG and other clocks
create_clock -period 100.00 -name altera_reserved_tck [get_ports altera_reserved_tck]
set_clock_groups -asynchronous -group {altera_reserved_tck}

## Cutting paths for the JTAG tdo, tdi, and tms pins
set_false_path -to [get_ports altera_reserved_tdo]
set_false_path -from [get_ports altera_reserved_tdi]
set_false_path -from [get_ports altera_reserved_tms]

## ADC input clock
#create_clock -name clk_adc -period 50.000 [get_ports {sys_adc_feedback_clk}]
#create_clock -name clk_adc -period 50.000 [get_pins {u_doc|pll_0|altera_pll_i|general[3].gpll~PLL_OUTPUT_COUNTER|divclk}]

# Need to manually specify the MPFE input clock as it needs to be defined before running uniphy scripts
# but we can't run derive_pll_clocks until after uniphy scripts are run

#create_clock -name sys_clk_100 -period 10.000 [get_pins {u_doc|altpll_0|sd1|generic_pll9~PLL_OUTPUT_COUNTER|divclk}]
