----------------------------------------------------------------------------- 
-- Altera DSP Builder Advanced Flow Tools Release Version 12.0sp2
-- Quartus II development tool and MATLAB/Simulink Interface
-- 
-- Legal Notice: Copyright 2012 Altera Corporation.  All rights reserved.    
-- Your use of  Altera  Corporation's design tools,  logic functions and other 
-- software and tools,  and its AMPP  partner logic functions, and  any output 
-- files  any of the  foregoing  device programming or simulation files),  and 
-- any associated  documentation or information are expressly subject  to  the 
-- terms and conditions  of the Altera Program License Subscription Agreement, 
-- Altera  MegaCore  Function  License  Agreement, or other applicable license 
-- agreement,  including,  without limitation,  that your use  is for the sole 
-- purpose of  programming  logic  devices  manufactured by Altera and sold by 
-- Altera or its authorized  distributors.  Please  refer  to  the  applicable 
-- agreement for further details.
----------------------------------------------------------------------------- 

-- VHDL created from DOC_FOC_fixp16_ax4_FOC_FL
-- VHDL created on Wed Aug 29 14:41:36 2012


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.NUMERIC_STD.all;
use std.TextIO.all;
USE work.DOC_FOC_fixp16_ax4_safe_path.all;

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3097
entity DOC_FOC_fixp16_ax4_FOC_FL_stm is
    port (
         dv_stm : out std_logic_vector(0 downto 0);
         dc_stm : out std_logic_vector(7 downto 0);
         valid_in_stm : out std_logic_vector(0 downto 0);
         axis_in_stm : out std_logic_vector(7 downto 0);
         Iu_stm : out std_logic_vector(15 downto 0);
         Iw_stm : out std_logic_vector(15 downto 0);
         Torque_stm : out std_logic_vector(15 downto 0);
         IntegralQ_in_stm : out std_logic_vector(15 downto 0);
         IntegralD_in_stm : out std_logic_vector(15 downto 0);
         phi_el_stm : out std_logic_vector(15 downto 0);
         Kp_stm : out std_logic_vector(15 downto 0);
         Ki_stm : out std_logic_vector(15 downto 0);
         U_Sat_Limit_stm : out std_logic_vector(15 downto 0);
         I_Sat_Limit_stm : out std_logic_vector(15 downto 0);
         qv_stm : out std_logic_vector(0 downto 0);
         qc_stm : out std_logic_vector(7 downto 0);
         valid_out_stm : out std_logic_vector(0 downto 0);
         axis_out_stm : out std_logic_vector(7 downto 0);
         Valpha_stm : out std_logic_vector(31 downto 0);
         Vbeta_stm : out std_logic_vector(31 downto 0);
         IntegralD_out_stm : out std_logic_vector(15 downto 0);
         IntegralQ_out_stm : out std_logic_vector(15 downto 0);
         debug_1_stm : out std_logic_vector(15 downto 0);
         debug_2_stm : out std_logic_vector(15 downto 0);
         debug_3_stm : out std_logic_vector(15 downto 0);
        clk : out std_logic;
        areset : out std_logic;
        h_areset : out std_logic
    );
end;

architecture normal of DOC_FOC_fixp16_ax4_FOC_FL_stm is

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3106
    signal clk_stm_sig : std_logic := '0';
    signal clk_stm_sig_stop : std_logic := '0';
    signal areset_stm_sig : std_logic := '1';
    signal h_areset_stm_sig : std_logic := '1';
    signal clk_ChannelIn_stm_sig_stop : std_logic := '0';
    signal clk_ChannelOut_stm_sig_stop : std_logic := '0';

    function str_to_stdvec(inp: string) return std_logic_vector is
        variable temp: std_logic_vector(inp'range) := (others => 'X');
    begin
        for i in inp'range loop
            if (inp(i) = '1') then
                temp(i) := '1';
            elsif (inp(i) = '0') then
                temp(i) := '0';
            end if;
        end loop;
        return temp;
    end function str_to_stdvec;

begin
    clk <= clk_stm_sig;
    clk_process: process 
    begin
        wait for 200 ps;
        clk_stm_sig <= not clk_stm_sig;
        wait for 4800 ps;
        if (clk_stm_sig_stop = '1') then
            assert (false)
            report "Arrived at end of stimulus data on clk clk" severity NOTE;
            wait;
        end if;
        wait for 200 ps;
        clk_stm_sig <= not clk_stm_sig;
        wait for 4800 ps;
        if (clk_stm_sig_stop = '1') then
            assert (false)
            report "Arrived at end of stimulus data on clk clk" severity NOTE;
            wait;
        end if;
    end process;

    areset <= areset_stm_sig;
    areset_process: process begin
        areset_stm_sig <= '1';
        wait for 7500 ps;
        areset_stm_sig <= '0';
        wait;
    end process;

    h_areset <= h_areset_stm_sig;
    h_areset_process: process begin
        h_areset_stm_sig <= '1';
        wait for 7500 ps;
        h_areset_stm_sig <= '0';
        wait;
    end process;

    --Generating stimulus for ChannelIn
    ChannelIn_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelIn : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelIn.stm");
        variable dv_int_0 : Integer;
        variable dv_temp : std_logic_vector(0 downto 0);
        variable dc_int_0 : Integer;
        variable dc_temp : std_logic_vector(7 downto 0);
        variable valid_in_int_0 : Integer;
        variable valid_in_temp : std_logic_vector(0 downto 0);
        variable axis_in_int_0 : Integer;
        variable axis_in_temp : std_logic_vector(7 downto 0);
        variable Iu_int_0 : Integer;
        variable Iu_temp : std_logic_vector(15 downto 0);
        variable Iw_int_0 : Integer;
        variable Iw_temp : std_logic_vector(15 downto 0);
        variable Torque_int_0 : Integer;
        variable Torque_temp : std_logic_vector(15 downto 0);
        variable IntegralQ_in_int_0 : Integer;
        variable IntegralQ_in_temp : std_logic_vector(15 downto 0);
        variable IntegralD_in_int_0 : Integer;
        variable IntegralD_in_temp : std_logic_vector(15 downto 0);
        variable phi_el_int_0 : Integer;
        variable phi_el_temp : std_logic_vector(15 downto 0);
        variable Kp_int_0 : Integer;
        variable Kp_temp : std_logic_vector(15 downto 0);
        variable Ki_int_0 : Integer;
        variable Ki_temp : std_logic_vector(15 downto 0);
        variable U_Sat_Limit_int_0 : Integer;
        variable U_Sat_Limit_temp : std_logic_vector(15 downto 0);
        variable I_Sat_Limit_int_0 : Integer;
        variable I_Sat_Limit_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        dv_stm <= (others => '0');
        dc_stm <= (others => '0');
        valid_in_stm <= (others => '0');
        axis_in_stm <= (others => '0');
        Iu_stm <= (others => '0');
        Iw_stm <= (others => '0');
        Torque_stm <= (others => '0');
        IntegralQ_in_stm <= (others => '0');
        IntegralD_in_stm <= (others => '0');
        phi_el_stm <= (others => '0');
        Kp_stm <= (others => '0');
        Ki_stm <= (others => '0');
        U_Sat_Limit_stm <= (others => '0');
        I_Sat_Limit_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            if endfile(data_file_ChannelIn) then
                clk_ChannelIn_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelIn, L);

                read(L, dv_int_0);
                dv_temp(0 downto 0) := std_logic_vector(to_unsigned(dv_int_0, 1));
                dv_stm <= dv_temp;
                read(L, dc_int_0);
                dc_temp(7 downto 0) := std_logic_vector(to_unsigned(dc_int_0, 8));
                dc_stm <= dc_temp;
                read(L, valid_in_int_0);
                valid_in_temp(0 downto 0) := std_logic_vector(to_unsigned(valid_in_int_0, 1));
                valid_in_stm <= valid_in_temp;
                read(L, axis_in_int_0);
                axis_in_temp(7 downto 0) := std_logic_vector(to_unsigned(axis_in_int_0, 8));
                axis_in_stm <= axis_in_temp;
                read(L, Iu_int_0);
                Iu_temp(15 downto 0) := std_logic_vector(to_unsigned(Iu_int_0, 16));
                Iu_stm <= Iu_temp;
                read(L, Iw_int_0);
                Iw_temp(15 downto 0) := std_logic_vector(to_unsigned(Iw_int_0, 16));
                Iw_stm <= Iw_temp;
                read(L, Torque_int_0);
                Torque_temp(15 downto 0) := std_logic_vector(to_unsigned(Torque_int_0, 16));
                Torque_stm <= Torque_temp;
                read(L, IntegralQ_in_int_0);
                IntegralQ_in_temp(15 downto 0) := std_logic_vector(to_unsigned(IntegralQ_in_int_0, 16));
                IntegralQ_in_stm <= IntegralQ_in_temp;
                read(L, IntegralD_in_int_0);
                IntegralD_in_temp(15 downto 0) := std_logic_vector(to_unsigned(IntegralD_in_int_0, 16));
                IntegralD_in_stm <= IntegralD_in_temp;
                read(L, phi_el_int_0);
                phi_el_temp(15 downto 0) := std_logic_vector(to_unsigned(phi_el_int_0, 16));
                phi_el_stm <= phi_el_temp;
                read(L, Kp_int_0);
                Kp_temp(15 downto 0) := std_logic_vector(to_unsigned(Kp_int_0, 16));
                Kp_stm <= Kp_temp;
                read(L, Ki_int_0);
                Ki_temp(15 downto 0) := std_logic_vector(to_unsigned(Ki_int_0, 16));
                Ki_stm <= Ki_temp;
                read(L, U_Sat_Limit_int_0);
                U_Sat_Limit_temp(15 downto 0) := std_logic_vector(to_unsigned(U_Sat_Limit_int_0, 16));
                U_Sat_Limit_stm <= U_Sat_Limit_temp;
                read(L, I_Sat_Limit_int_0);
                I_Sat_Limit_temp(15 downto 0) := std_logic_vector(to_unsigned(I_Sat_Limit_int_0, 16));
                I_Sat_Limit_stm <= I_Sat_Limit_temp;

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;

    --Generating stimulus for ChannelOut
    ChannelOut_stm_init_p: process

        variable L : line;
        variable dummy_int : Integer;

        file data_file_ChannelOut : text open read_mode is safe_path("DOC_FOC_fixp16_ax4/FOC/FL/ChannelOut.stm");
        variable qv_int_0 : Integer;
        variable qv_temp : std_logic_vector(0 downto 0);
        variable qc_int_0 : Integer;
        variable qc_temp : std_logic_vector(7 downto 0);
        variable valid_out_int_0 : Integer;
        variable valid_out_temp : std_logic_vector(0 downto 0);
        variable axis_out_int_0 : Integer;
        variable axis_out_temp : std_logic_vector(7 downto 0);
        variable Valpha_int_0 : Integer;
        variable Valpha_temp : std_logic_vector(31 downto 0);
        variable Vbeta_int_0 : Integer;
        variable Vbeta_temp : std_logic_vector(31 downto 0);
        variable IntegralD_out_int_0 : Integer;
        variable IntegralD_out_temp : std_logic_vector(15 downto 0);
        variable IntegralQ_out_int_0 : Integer;
        variable IntegralQ_out_temp : std_logic_vector(15 downto 0);
        variable debug_1_int_0 : Integer;
        variable debug_1_temp : std_logic_vector(15 downto 0);
        variable debug_2_int_0 : Integer;
        variable debug_2_temp : std_logic_vector(15 downto 0);
        variable debug_3_int_0 : Integer;
        variable debug_3_temp : std_logic_vector(15 downto 0);

    begin
        -- initialize all outputs to 0
        qv_stm <= (others => '0');
        qc_stm <= (others => '0');
        valid_out_stm <= (others => '0');
        axis_out_stm <= (others => '0');
        Valpha_stm <= (others => '0');
        Vbeta_stm <= (others => '0');
        IntegralD_out_stm <= (others => '0');
        IntegralQ_out_stm <= (others => '0');
        debug_1_stm <= (others => '0');
        debug_2_stm <= (others => '0');
        debug_3_stm <= (others => '0');

        wait for 201 ps; -- wait delay

        while true loop

            if endfile(data_file_ChannelOut) then
                clk_ChannelOut_stm_sig_stop <= '1';
                wait;
            else
                readline(data_file_ChannelOut, L);

                read(L, qv_int_0);
                qv_temp(0 downto 0) := std_logic_vector(to_unsigned(qv_int_0, 1));
                qv_stm <= qv_temp;
                read(L, qc_int_0);
                qc_temp(7 downto 0) := std_logic_vector(to_unsigned(qc_int_0, 8));
                qc_stm <= qc_temp;
                read(L, valid_out_int_0);
                valid_out_temp(0 downto 0) := std_logic_vector(to_unsigned(valid_out_int_0, 1));
                valid_out_stm <= valid_out_temp;
                read(L, axis_out_int_0);
                axis_out_temp(7 downto 0) := std_logic_vector(to_unsigned(axis_out_int_0, 8));
                axis_out_stm <= axis_out_temp;
                read(L, Valpha_int_0);
                Valpha_temp(31 downto 0) := std_logic_vector(to_signed(Valpha_int_0, 32));
                Valpha_stm <= Valpha_temp;
                read(L, Vbeta_int_0);
                Vbeta_temp(31 downto 0) := std_logic_vector(to_signed(Vbeta_int_0, 32));
                Vbeta_stm <= Vbeta_temp;
                read(L, IntegralD_out_int_0);
                IntegralD_out_temp(15 downto 0) := std_logic_vector(to_unsigned(IntegralD_out_int_0, 16));
                IntegralD_out_stm <= IntegralD_out_temp;
                read(L, IntegralQ_out_int_0);
                IntegralQ_out_temp(15 downto 0) := std_logic_vector(to_unsigned(IntegralQ_out_int_0, 16));
                IntegralQ_out_stm <= IntegralQ_out_temp;
                read(L, debug_1_int_0);
                debug_1_temp(15 downto 0) := std_logic_vector(to_unsigned(debug_1_int_0, 16));
                debug_1_stm <= debug_1_temp;
                read(L, debug_2_int_0);
                debug_2_temp(15 downto 0) := std_logic_vector(to_unsigned(debug_2_int_0, 16));
                debug_2_stm <= debug_2_temp;
                read(L, debug_3_int_0);
                debug_3_temp(15 downto 0) := std_logic_vector(to_unsigned(debug_3_int_0, 16));
                debug_3_stm <= debug_3_temp;

                deallocate(L);
            end if;

            -- wait for rising edge to pass (assert signals just after rising edge)
            wait until clk_stm_sig'EVENT and clk_stm_sig = '1';
            wait for 1 ps; -- wait delay

        end loop;

        wait;
    end process;


    clk_stm_sig_stop <= clk_ChannelIn_stm_sig_stop OR clk_ChannelOut_stm_sig_stop OR '0';

end;
