----------------------------------------------------------------------------- 
-- Altera DSP Builder Advanced Flow Tools Release Version 12.0sp2
-- Quartus II development tool and MATLAB/Simulink Interface
-- 
-- Legal Notice: Copyright 2012 Altera Corporation.  All rights reserved.    
-- Your use of  Altera  Corporation's design tools,  logic functions and other 
-- software and tools,  and its AMPP  partner logic functions, and  any output 
-- files  any of the  foregoing  device programming or simulation files),  and 
-- any associated  documentation or information are expressly subject  to  the 
-- terms and conditions  of the Altera Program License Subscription Agreement, 
-- Altera  MegaCore  Function  License  Agreement, or other applicable license 
-- agreement,  including,  without limitation,  that your use  is for the sole 
-- purpose of  programming  logic  devices  manufactured by Altera and sold by 
-- Altera or its authorized  distributors.  Please  refer  to  the  applicable 
-- agreement for further details.
----------------------------------------------------------------------------- 

-- VHDL created from DOC_FOC_fixp16_ax4_FOC_fb_latches1
-- VHDL created on Wed Aug 29 14:41:36 2012


-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:2935
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.NUMERIC_STD.all;

entity DOC_FOC_fixp16_ax4_FOC_fb_latches1_atb is
end;

architecture normal of DOC_FOC_fixp16_ax4_FOC_fb_latches1_atb is

component DOC_FOC_fixp16_ax4_FOC_fb_latches1 is
    port (
        axis_in : in std_logic_vector(7 downto 0);
        axis_out : in std_logic_vector(7 downto 0);
        id_int : in std_logic_vector(15 downto 0);
        id_int_latch : out std_logic_vector(15 downto 0);
        iq_int : in std_logic_vector(15 downto 0);
        iq_int_latch : out std_logic_vector(15 downto 0);
        qv : in std_logic_vector(0 downto 0);
        reset : in std_logic_vector(0 downto 0);
        valid_out : in std_logic_vector(0 downto 0);
        clk : in std_logic;
        areset : in std_logic;
        h_areset : in std_logic
        );
end component;

component DOC_FOC_fixp16_ax4_FOC_fb_latches1_stm is
    port (
         axis_in_stm : out std_logic_vector(7 downto 0);
         axis_out_stm : out std_logic_vector(7 downto 0);
         id_int_stm : out std_logic_vector(15 downto 0);
         id_int_latch_stm : out std_logic_vector(15 downto 0);
         iq_int_stm : out std_logic_vector(15 downto 0);
         iq_int_latch_stm : out std_logic_vector(15 downto 0);
         qv_stm : out std_logic_vector(0 downto 0);
         reset_stm : out std_logic_vector(0 downto 0);
         valid_out_stm : out std_logic_vector(0 downto 0);
        clk : out std_logic;
        areset : out std_logic;
        h_areset : out std_logic
    );
end component;

    signal axis_in_stm : std_logic_vector(7 downto 0);
    signal axis_out_stm : std_logic_vector(7 downto 0);
    signal id_int_stm : std_logic_vector(15 downto 0);
    signal id_int_latch_stm : std_logic_vector(15 downto 0);
    signal iq_int_stm : std_logic_vector(15 downto 0);
    signal iq_int_latch_stm : std_logic_vector(15 downto 0);
    signal qv_stm : std_logic_vector(0 downto 0);
    signal reset_stm : std_logic_vector(0 downto 0);
    signal valid_out_stm : std_logic_vector(0 downto 0);
    signal axis_in : std_logic_vector(7 downto 0);
    signal axis_out : std_logic_vector(7 downto 0);
    signal id_int : std_logic_vector(15 downto 0);
    signal id_int_latch : std_logic_vector(15 downto 0);
    signal iq_int : std_logic_vector(15 downto 0);
    signal iq_int_latch : std_logic_vector(15 downto 0);
    signal qv : std_logic_vector(0 downto 0);
    signal reset : std_logic_vector(0 downto 0);
    signal valid_out : std_logic_vector(0 downto 0);
        signal clk : std_logic;
        signal areset : std_logic;
        signal h_areset : std_logic;

begin

-- General Purpose data out check
checkid_int_latch_auto : process (clk, areset)
    variable mismatch_id_int_latch : BOOLEAN := FALSE;
    variable ok : BOOLEAN := TRUE;
begin
    IF (areset = '1') THEN 
        -- do nothing during reset
    ELSIF (clk'EVENT AND clk = '0') THEN -- falling clock edge to avoid transitions
        ok := TRUE;
        mismatch_id_int_latch := FALSE;
        if (id_int_latch /= id_int_latch_stm) then
            mismatch_id_int_latch := TRUE;
            report "Mismatch on device output pin id_int_latch" severity Warning;
        end if;
        if mismatch_id_int_latch then
            ok := FALSE;
        end if;
        assert (ok)
        report "mismatch in general purpose signal. Check the status of any associated valid signals." severity Warning;
    end if;
end process;


-- General Purpose data out check
checkiq_int_latch_auto : process (clk, areset)
    variable mismatch_iq_int_latch : BOOLEAN := FALSE;
    variable ok : BOOLEAN := TRUE;
begin
    IF (areset = '1') THEN 
        -- do nothing during reset
    ELSIF (clk'EVENT AND clk = '0') THEN -- falling clock edge to avoid transitions
        ok := TRUE;
        mismatch_iq_int_latch := FALSE;
        if (iq_int_latch /= iq_int_latch_stm) then
            mismatch_iq_int_latch := TRUE;
            report "Mismatch on device output pin iq_int_latch" severity Warning;
        end if;
        if mismatch_iq_int_latch then
            ok := FALSE;
        end if;
        assert (ok)
        report "mismatch in general purpose signal. Check the status of any associated valid signals." severity Warning;
    end if;
end process;


dut : DOC_FOC_fixp16_ax4_FOC_fb_latches1 port map (
         axis_in_stm,
         axis_out_stm,
         id_int_stm,
         id_int_latch,
         iq_int_stm,
         iq_int_latch,
         qv_stm,
         reset_stm,
         valid_out_stm,
        clk,
        areset,
        h_areset
        );

sim : DOC_FOC_fixp16_ax4_FOC_fb_latches1_stm port map (
         axis_in_stm,
         axis_out_stm,
         id_int_stm,
         id_int_latch_stm,
         iq_int_stm,
         iq_int_latch_stm,
         qv_stm,
         reset_stm,
         valid_out_stm,
        clk,
        areset,
        h_areset
     );

end normal;
