----------------------------------------------------------------------------- 
-- Altera DSP Builder Advanced Flow Tools Release Version 12.0sp2
-- Quartus II development tool and MATLAB/Simulink Interface
-- 
-- Legal Notice: Copyright 2012 Altera Corporation.  All rights reserved.    
-- Your use of  Altera  Corporation's design tools,  logic functions and other 
-- software and tools,  and its AMPP  partner logic functions, and  any output 
-- files  any of the  foregoing  device programming or simulation files),  and 
-- any associated  documentation or information are expressly subject  to  the 
-- terms and conditions  of the Altera Program License Subscription Agreement, 
-- Altera  MegaCore  Function  License  Agreement, or other applicable license 
-- agreement,  including,  without limitation,  that your use  is for the sole 
-- purpose of  programming  logic  devices  manufactured by Altera and sold by 
-- Altera or its authorized  distributors.  Please  refer  to  the  applicable 
-- agreement for further details.
----------------------------------------------------------------------------- 

-- VHDL created from DOC_FOC_fixp16_ax4_FOC_fb_latches1
-- VHDL created on Wed Aug 29 14:41:36 2012


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.NUMERIC_STD.all;
use std.TextIO.all;
USE work.DOC_FOC_fixp16_ax4_safe_path.all;

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3097
entity DOC_FOC_fixp16_ax4_FOC_fb_latches1_stm is
    port (
         axis_in_stm : out std_logic_vector(7 downto 0);
         axis_out_stm : out std_logic_vector(7 downto 0);
         id_int_stm : out std_logic_vector(15 downto 0);
         id_int_latch_stm : out std_logic_vector(15 downto 0);
         iq_int_stm : out std_logic_vector(15 downto 0);
         iq_int_latch_stm : out std_logic_vector(15 downto 0);
         qv_stm : out std_logic_vector(0 downto 0);
         reset_stm : out std_logic_vector(0 downto 0);
         valid_out_stm : out std_logic_vector(0 downto 0);
        clk : out std_logic;
        areset : out std_logic;
        h_areset : out std_logic
    );
end;

architecture normal of DOC_FOC_fixp16_ax4_FOC_fb_latches1_stm is

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3106
    signal clk_stm_sig : std_logic := '0';
    signal clk_stm_sig_stop : std_logic := '0';
    signal areset_stm_sig : std_logic := '1';
    signal h_areset_stm_sig : std_logic := '1';

    function str_to_stdvec(inp: string) return std_logic_vector is
        variable temp: std_logic_vector(inp'range) := (others => 'X');
    begin
        for i in inp'range loop
            if (inp(i) = '1') then
                temp(i) := '1';
            elsif (inp(i) = '0') then
                temp(i) := '0';
            end if;
        end loop;
        return temp;
    end function str_to_stdvec;

begin
    clk <= clk_stm_sig;
    clk_process: process 
    begin
        wait for 200 ps;
        clk_stm_sig <= not clk_stm_sig;
        wait for 4800 ps;
        if (clk_stm_sig_stop = '1') then
            assert (false)
            report "Arrived at end of stimulus data on clk clk" severity NOTE;
            wait;
        end if;
        wait for 200 ps;
        clk_stm_sig <= not clk_stm_sig;
        wait for 4800 ps;
        if (clk_stm_sig_stop = '1') then
            assert (false)
            report "Arrived at end of stimulus data on clk clk" severity NOTE;
            wait;
        end if;
    end process;

    areset <= areset_stm_sig;
    areset_process: process begin
        areset_stm_sig <= '1';
        wait for 7500 ps;
        areset_stm_sig <= '0';
        wait;
    end process;

    h_areset <= h_areset_stm_sig;
    h_areset_process: process begin
        h_areset_stm_sig <= '1';
        wait for 7500 ps;
        h_areset_stm_sig <= '0';
        wait;
    end process;

-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for axis_in_auto signals
    axis_in_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for axis_out_auto signals
    axis_out_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for id_int_auto signals
    id_int_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for id_int_latch_auto signals
    id_int_latch_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for iq_int_auto signals
    iq_int_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for iq_int_latch_auto signals
    iq_int_latch_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for qv_auto signals
    qv_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for reset_auto signals
    reset_stm <= (others => '0');
-- Text written from d:/SJ/nightly/12.0sp2/263/w32/p4/ip/aion/src/mip_common/hw_model.cpp:3169
    --Driving gnd for valid_out_auto signals
    valid_out_stm <= (others => '0');

    clk_stm_sig_stop <= '1';

end;
